/*************************************************************
*	PROGETTO LABIRINTO
*
* nome file: <geometria.h>
*
* Autori:
* Thomas Carrabs
* Roberto Pisoni
*
* Progetto realizzato per l'esame di Geometria Computazionale
* e di Informatica Grafica presso il Dipartimento di Scienze
* dell'Informazione dell'universit Statale di Milano
*
* Tutto il codice  distribuito sotto licenza Gnu/GPL
* http://www.gnu.org/copyleft/gpl.html
* una copia della licenza si trova nella cartella License del
* Progetto
*
*************************************************************/
#include <GL/glut.h>

#define MAX_TEXTURES 6			//numero massimo di texture usate
#define GAP  20					//distanza tra le varie finestre

void main_fin_reshape(int w, int h);		//callback reshape finestra principale
void main_fin_display(void);				//callback display finestra principale
void stampastringa(GLuint x, GLuint y, char* stringa);		//funzione per la stampa di stringhe
void main_fin_tastiera(unsigned char key, int x, int y);	//callback per gestione tastiera nella finestra principale
void prosp_reshape(int w, int h);			//callback reshape per la finestra della prospettiva
void prosp_display(void);					//callback display per la finestra della prospettiva
void lab3d_reshape(int w, int h);			//callback reshape per la finestra con il labirinto 3D
void lab3d_display(void);					//callback display per la finestra con il labirinto 3D
void mappa_reshape(int w, int h);			//callback reshape per la finestra con la mappa labirinto
void mappa_display(void);					//callback display per la finestra con la mappa labirinto
void help_reshape(int w, int h);			//callback reshape per la finestra con help
void help_display(void);					//callback display per la finestra con help
void redisplay_all(void);					//richiama tutte le reshape callback


void geometria(int argc, char *argv[]);
/*
 * main di geometria e info grafica
 */

struct coordCella{
	short int numeroPT; 
	GLsizei coordPT[4][2];
	GLubyte *ordPT;
};

typedef struct coordCella coordCella; //utilizzata per disegnare con il multiDraw

struct coordQuad{
	short int numeroPT; //saper quanti quad disegnare 1-2
	GLsizei coordPT[6][3]; //coordinate 3D dispari base pari altezza
	GLsizei coordNO[2][3];
};

typedef struct coordQuad coordQuad;

void aggiornaRotazione(void);
/*
 * Aggiorna i valori di rotazione della telecamera
 */

void aggiornaTraslazione(void);
/*
 * Aggiorna i valori di traslazione della telecamera
 */

short int collisione(int ID);
/*
 * Semplice funzione che gestisce la collisione della telecamera con i muri
 * Visto che si tratta di verificare la collisione tra superfici piane e un 
 * singolo punto si  optato per il semplice confronto delle cordiante x e z.
 * la telecamera non pu infatti muoversi lungo l'asse y
 *
 * Il Confronto viene eseguito in base alla tipologia dell'attuale cella di labirnito
 * NORD,SUD,EST,OVEST indicano la presenza di un passaggio in quella direzione
 */

