/*************************************************************
*	PROGETTO LABIRINTO
*
* nome file: <stack.c>
*
* Autori:
* Thomas Carrabs
* Roberto Pisoni
*
* Progetto realizzato per l'esame di Geometria Computazionale
* e di Informatica Grafica presso il Dipartimento di Scienze
* dell'Informazione dell'universit Statale di Milano
*
* Tutto il codice  distribuito sotto licenza Gnu/GPL
* http://www.gnu.org/copyleft/gpl.html
* una copia della licenza si trova nella cartella License del
* Progetto
*
*************************************************************/

#include "labirinto.h"
#include "stack.h"

//Funzione che crea lo stack.
void creaStack(stack *stack){
	stack->ctr = 0;		//contatore elementi dello stack
	stack->top = NULL;	//puntatore al primo elemento nello stack
}

//Funzione che pone un elemento sullo stack
void pushStack(stack *stack, cella *pcella){
	struct stk_cella *c;
	
	//Crea un elemento di tipo stk_cella da porre nello stack
	if((c=calloc(1,sizeof(struct stk_cella)))==NULL){
		printf("Errore nella creazione di un elemento nello stack");
		exit(0);
	}
	c->id = pcella->id;		//aggiorna id della cella
	c->next = stack->top;	//la nuova cella punta a quella vecchia
	stack->top = c;			//aggiorno ptr: punta alla nuova cella creata
	stack->ctr++;			// stato aggiunto un elemento allo stack
}

//Funzione che prende l'elemento in cima allo stack
int popStack(stack *stack){
	struct stk_cella *ptrcella;
	int id_cella;
	
	if(stack->top == NULL){
		printf("labirinto creato\n");
		return -1;
	}
	id_cella = stack->top->id;		//ritorna l'ID corretto della cella in cima allo stack
	ptrcella = stack->top;			//ptrcella punta all'elemento in cima allo stack
	stack->top = stack->top->next;	//aggiorno il ptr al primo elemento dello stack (successivo a quello attuale)
	stack->ctr--;					//decremento di 1 gli elementi della coda
	free(ptrcella);
	return id_cella;				//id cella in cima allo stack
}
